VERSION 5.00
Begin VB.Form frmHelp 
   AutoRedraw      =   -1  'True
   BorderStyle     =   0  'None
   ClientHeight    =   2520
   ClientLeft      =   3030
   ClientTop       =   2700
   ClientWidth     =   2640
   ControlBox      =   0   'False
   Icon            =   "Qtip.frx":0000
   MaxButton       =   0   'False
   MinButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   168
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   176
   ShowInTaskbar   =   0   'False
End
Attribute VB_Name = "frmHelp"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' On Top API Calls.
Private Const HWND_TOPMOST = -&H1
Private Const HWND_NOTOPMOST = -&H2
Private Const SWP_NOSIZE = &H1
Private Const SWP_NOMOVE = &H2
Private bOnTopState As Boolean
Private Declare Sub SetWindowPos Lib "user32" (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long)
'------------------
' Captionless drag Messages.
Private Const WM_NCLBUTTONDOWN = &HA1
Private Const HTCAPTION = 2
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function ReleaseCapture Lib "user32" () As Long
'------------------

' API Region Calls.
Private Declare Function CreateRoundRectRgn Lib "gdi32" (ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long, ByVal X3 As Long, ByVal Y3 As Long) As Long
Private Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
Private Declare Function FrameRgn Lib "gdi32" (ByVal hDC As Long, ByVal hRgn As Long, ByVal hBrush As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Private Declare Function SetWindowRgn Lib "user32" (ByVal hWnd As Long, ByVal hRgn As Long, ByVal bRedraw As Long) As Long

Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type
Private tipRC As RECT
Private TipBox As RECT

' Region size Variable
Private mlTipBox As Long
' Brush for Framing the region.
Private hBrush As Long

' DrawText API Constants and Function Declarations.
Private Declare Function DrawText Lib "user32" Alias "DrawTextA" (ByVal hDC As Long, ByVal lpStr As String, ByVal nCount As Long, lpRect As RECT, ByVal wFormat As Long) As Long
Private Const DT_TOP = &H0
Private Const DT_LEFT = &H0
Private Const DT_CENTER = &H1
Private Const DT_RIGHT = &H2
Private Const DT_VCENTER = &H4
Private Const DT_BOTTOM = &H8
Private Const DT_CALCRECT = &H400
Private Const DT_WORDBREAK = &H10

Public Property Let AlwaysOnTop(bState As Boolean)
    Dim lFlag As Long
    On Error Resume Next
    If bState = True Then
        lFlag = HWND_TOPMOST
    Else
        lFlag = HWND_NOTOPMOST
    End If
    bOnTopState = bState
    Call SetWindowPos(Me.hWnd, lFlag, 0&, 0&, 0&, 0&, (SWP_NOSIZE Or SWP_NOMOVE))
End Property

Public Property Get AlwaysOnTop() As Boolean
    AlwaysOnTop = bOnTopState
End Property

Private Sub Form_DblClick()
    Unload Me
End Sub

Private Sub Form_KeyPress(KeyAscii As Integer)
    If KeyAscii = 13 Then Unload Me
End Sub

Private Sub Form_Load()
    Me.AlwaysOnTop = True
    Dim lRet As Long
    ' DrawText is a Normal Integer Call, not a Long.
    Dim iDrawTxt As Integer, sHelp As String
    ' Region dimensions X1/X2, Y1/Y2
    Dim lTipWidth As Long, lTipHeight As Long
    ' Corner Radius for the round rectangle.
    Dim lCorner As Long

    ' All the tip and form parameters, have
    ' been set in the SetHelpText function, so
    ' we can say the loading is happening.
    gbTipLoaded = True
    frmMain.sbWizard.Caption = "Double-Click the Tip window to close it."

    ' Corner radius in Points. Its a rounded rectangle
    ' so the API wants this factor, adjust to suit.
    ' It could also be adjusted, depending on Screen Metrics.
    lCorner = 36

    Me.Left = Screen.Width - Me.Width
    Me.Top = Screen.Height - (Me.Height + 400)
    lTipWidth = Me.ScaleWidth
    lTipHeight = Me.ScaleHeight

    ' System colors can't be set at Design time, so let the OS tell us.
    Me.BackColor = vbInfoBackground
    Me.ForeColor = vbInfoText

    ' Set up the Text drawing rectangle.
    tipRC.Top = lCorner / 2
    tipRC.Left = lCorner / 2
    tipRC.Right = Me.ScaleWidth - lCorner / 2
    tipRC.Bottom = Me.ScaleHeight - lCorner / 2

    mlTipBox = CreateRoundRectRgn(0, 0, lTipWidth, lTipHeight, lCorner, lCorner)

    hBrush = CreateSolidBrush(vbDesktop)
    lRet = FrameRgn(Me.hDC, mlTipBox, hBrush, 3, 3)
    lRet = SetWindowRgn(Me.hWnd, mlTipBox, True)
    'LoadFormMsgs
    ' Get the help text for this call.
    sHelp = gsHelp(TipID)

    ' If the text string is Null Terminated, this -1 version is ok.
    ' Check the SDK or Dan Appleman's 32-bit API Guide for other DT_variations.
    'iDrawTxt = DrawText(hDC, sHelp, -1, tipRC, DT_WORDBREAK)

    ' If its from a file or other, better use its length (Len(sHelp).
    ' This first call sets up to calculate the drawn size.
    ' DT_CALCRECT constant.
    iDrawTxt = DrawText(hDC, sHelp, Len(sHelp), tipRC, DT_LEFT Or DT_CALCRECT Or DT_WORDBREAK)
    Me.Refresh ' This clears the drawing area of any e-junk from this above.

    ' This second one draws it.
    iDrawTxt = DrawText(hDC, sHelp, Len(sHelp), tipRC, DT_LEFT Or DT_WORDBREAK)
End Sub

Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    ' Allows captionless drag if form is clipped to region.
    Call ReleaseCapture
    Call SendMessage(Me.hWnd, WM_NCLBUTTONDOWN, HTCAPTION, 0&)
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    Dim lRet As Long
    gbTipLoaded = False
    
    Me.AlwaysOnTop = False
    frmMain.sbWizard.Caption = "Ready"
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Unload frmHelp
    Set frmHelp = Nothing
End Sub
